﻿#pragma strict

private var sfx:AudioSource;

public var pause:boolean = false;
public var worldMode:String = "overworld";

private var changingToUnderWorld:boolean = false;
private var changingToOverWorld:boolean = false;
private var resurrecting:boolean = false;
private var changing:boolean = false;
private var startTime:float;

private var sleepingBones:GameObject[];
private var sleepingSpirits:GameObject[];

public var player_object:GameObject;

private var helpOff:boolean = false;
public var portal:GameObject;
public var endScreen:GameObject;

public var cont_lives:int = 0;
public var cont_undead:int = 0;
public var cont_souls:int = 0;

private var end:boolean = false;

function Start () {
	sfx = GameObject.Find("Sfx").GetComponent(AudioSource);
}

function Update(){
	if(Input.anyKeyDown){
		helpOff = true;	
	}
	
	if(Input.GetKeyDown(KeyCode.Escape)){
		Application.Quit();
	}
	
	if(helpOff){
		var hs:SpriteRenderer = GameObject.Find("help").GetComponent(SpriteRenderer);
		var ls:SpriteRenderer = GameObject.Find("logo").GetComponent(SpriteRenderer);
		if(hs.color.a > 0){
			hs.color.a -= 0.01;
			ls.color.a -= 0.01;
		}
	}
	
	if(endScreen.activeSelf){
		if(endScreen.renderer.material.color.a < 1){
			endScreen.renderer.material.color.a += 0.01;
		} else {
			if(Input.anyKeyDown){
				Application.LoadLevel("map1");
			}
			endScreen.transform.Find("Texts").gameObject.SetActive(true);
			if(!end){
				endScreen.transform.Find("Texts").Find("Text_lives").GetComponent(TextMesh).text = endScreen.transform.Find("Texts").Find("Text_lives").GetComponent(TextMesh).text + cont_lives;
				endScreen.transform.Find("Texts").Find("Text_undead").GetComponent(TextMesh).text = endScreen.transform.Find("Texts").Find("Text_undead").GetComponent(TextMesh).text + cont_undead;
				endScreen.transform.Find("Texts").Find("Text_souls").GetComponent(TextMesh).text = endScreen.transform.Find("Texts").Find("Text_souls").GetComponent(TextMesh).text + cont_souls;
				end = true;
			}
		}
	}

	if(changing){
		portal.SetActive(false);
		var light:Light = GameObject.Find("light").GetComponent(Light);
		var amount:float;
		var pSpriteUp:SpriteRenderer;
		var spiritSprite:SpriteRenderer;
		if(player_object.GetComponent(PlayerController).playerMode == "bone"){
			pSpriteUp = player_object.transform.Find("sprite_group").Find("Player1_sprite_bone").GetComponent(SpriteRenderer);
		} else {
			pSpriteUp = player_object.transform.Find("sprite_group").Find("Player1_sprite").GetComponent(SpriteRenderer);
		}
	}
	if(changingToUnderWorld){		
		amount = (Time.time - startTime) / 4.0 / 80;
		light.color = Color.Lerp(light.color, new Color(0.06, 0.34, 0.32, 1), amount);
		light.transform.RotateAround(Vector3(0,1,0),0.60*Time.deltaTime);
		pSpriteUp.color = Color.Lerp(pSpriteUp.color, new Color(0.06, 0.34, 0.32, 0.5), amount);
		
		sleepingBones = GameObject.FindGameObjectsWithTag("enemy");
		for(var go in sleepingBones){
			Debug.Log(go.name);
			if(go.name == "esqueletus"){
				var boneSprite:SpriteRenderer = go.transform.Find("sprite").GetComponent(SpriteRenderer);
				boneSprite.color = Color.Lerp(boneSprite.color, new Color(0.06, 0.34, 0.32, 0), amount);
			}
		}
		
		if(Time.time - startTime >= 5){
			changingToUnderWorld = false;
			changing = false;
			player_object.GetComponent(PlayerController).health = 100;
			pause = false;
			worldMode = "underworld";
			
			for(var go in sleepingBones){
				if(go.name == "esqueletus"){
					go.SetActive(false);
				}
			}
		}
	}
	if(changingToOverWorld){
		amount = (Time.time - startTime) / 4.0 / 80;
		//light.color = Color.Lerp(light.color, new Color(0.9, 0.93, 0.92, 1), amount);
		light.color = Color.Lerp(light.color, new Color(1, 1, 1, 1), amount);
		light.transform.RotateAround(Vector3(0,1,0),-0.60*Time.deltaTime);
		pSpriteUp.color = Color.Lerp(pSpriteUp.color, new Color(1, 1, 1, 0), amount);
		
		sleepingSpirits = GameObject.FindGameObjectsWithTag("enemy");
		for(var go in sleepingSpirits){
			Debug.Log(go.name);
			if(go.name == "spiritus"){
				spiritSprite = go.transform.Find("sprite").GetComponent(SpriteRenderer);
				spiritSprite.color = Color.Lerp(spiritSprite.color, new Color(1, 1, 1, 0), amount);
			}
		}		
		
		if(Time.time - startTime >= 5){
			changingToOverWorld = false;
			changing = false;
			player_object.GetComponent(PlayerController).health = 100;
			pSpriteUp.color = new Color(1, 1, 1, 1);
			pause = false;
			worldMode = "overworld";
			
			for(var go in sleepingSpirits){
				if(go.name == "spiritus"){
					go.SetActive(false);
				}
			}
		}
	}
	
	if(resurrecting){
		amount = (Time.time - startTime) / 4.0 / 80;
		//light.color = Color.Lerp(light.color, new Color(0.9, 0.93, 0.92, 1), amount);
		light.color = Color.Lerp(light.color, new Color(1, 1, 1, 1), amount);
		light.transform.RotateAround(Vector3(0,1,0),-0.60*Time.deltaTime);
		pSpriteUp.color = Color.Lerp(pSpriteUp.color, new Color(1, 1, 1, 1), amount);
		
		sleepingSpirits = GameObject.FindGameObjectsWithTag("enemy");
		for(var go in sleepingSpirits){
			Debug.Log(go.name);
			if(go.name == "spiritus"){
				spiritSprite = go.transform.Find("sprite").GetComponent(SpriteRenderer);
				spiritSprite.color = Color.Lerp(spiritSprite.color, new Color(1, 1, 1, 0), amount);
			}
		}		
		
		if(Time.time - startTime >= 5){
			resurrecting = false;
			changing = false;
			//player_object.GetComponent(PlayerController).health = 20;
			player_object.GetComponent(PlayerController).playerMode = "human";
			pSpriteUp.color = new Color(1, 1, 1, 1);
			pause = false;
			worldMode = "overworld";
			
			for(var go in sleepingSpirits){
				if(go.name == "spiritus"){
					go.SetActive(false);
				}
			}
		}
	}
	
}

public function playSfx(name:String) {
	sfx.PlayOneShot(Resources.Load("Sounds/"+name, AudioClip));
}

public function showPortal(){
	portal.SetActive(true);
}

public function showEndScreen(){
	endScreen.SetActive(true);
}

public function resurrect(){
	pause = true;
	Debug.Log("whoaaa");
	resurrecting = true;
	changing = true;
	startTime = Time.time;
}

public function goToUnderWorld(){
	Debug.Log("whoaaa");
	changingToUnderWorld = true;
	changing = true;
	startTime = Time.time;
}

public function goToOverWorld(){
	Debug.Log("whoaaa");
	changingToOverWorld = true;
	changing = true;
	startTime = Time.time;
}