﻿#pragma strict

var speed : float = 6.0;
var jumpSpeed : float = 8.0;
var gravity : float = 20.0;

public var health:float = 100.0;
public var gm:GameObject;

public var swordHit:boolean = false;
public var hitObject:GameObject;

private var shielding:boolean = false;
public var attacking:boolean = false;
private var attackTime:float = 0.0;
private var ready:boolean = false;
public var ui_life_time:float = 0.0;

private var moveDirection : Vector3 = Vector3.zero;

private var impactMass:float = 3.0f;
private var impact:Vector3 = Vector3.zero;
private var character:CharacterController;

public var playerMode:String = "human";
public var sucking:boolean = false;


function Start () {
	character = GetComponent(CharacterController);
}

function Update() {

	var feet:String;
	var body:String;
	var anims:Animator;
	
	//if(!ready){
		//if(!attacking){
		if(playerMode == "bone"){
			//anims = transform.Find("sprite_group").Find("Player1_sprite").gameObject.GetComponent(Animator);
			//anims.Play("ely_bone_idle");
			transform.Find("sprite_group").Find("Player1_sprite").gameObject.SetActive(false);
			transform.Find("sprite_group").Find("Player1_sprite_bone").gameObject.SetActive(true);
			feet = "bonefeet";
			body = "_bone";
			speed = 2;
		} else {
			//anims = transform.Find("sprite_group").Find("Player1_sprite").gameObject.GetComponent(Animator);
			//anims.Play("ely_idle");
			transform.Find("sprite_group").Find("Player1_sprite").gameObject.SetActive(true);
			transform.Find("sprite_group").Find("Player1_sprite_bone").gameObject.SetActive(false);
			feet = "feet";
			body = "";
			if(sucking){
				speed = 1;
			} else {
				speed = 5;
			}
			if(transform.Find("sprite_group").Find("Player1_sprite").Find("evileyes").gameObject.activeSelf){
				if(transform.Find("sprite_group").Find("Player1_sprite").Find("evileyes").gameObject.GetComponent(SpriteRenderer).color.a > 0){
					transform.Find("sprite_group").Find("Player1_sprite").Find("evileyes").gameObject.GetComponent(SpriteRenderer).color.a -= 0.01;
				}
			}
		}
		//}
		//ready = true;
	//}

	if(!gm.GetComponent(GameManager).pause){

		if(transform.position.y < 0.3){
			transform.position.y = 0.3;
		}

		var controller : CharacterController = GetComponent(CharacterController); 

		if (controller.isGrounded) { 
		
			moveDirection = Vector3(Input.GetAxis("Horizontal"), 0, Input.GetAxis("Vertical")); 
			moveDirection = transform.TransformDirection(moveDirection); 
			moveDirection *= speed; 
			
			if(moveDirection.magnitude > 0){
				transform.Find("sprite_group").Find("Player1_sprite"+body).Find(feet).gameObject.SetActive(true);
				
				if(playerMode == "bone"){
					transform.Find("sprite_group").Find("Player1_sprite"+body).Find("feet").gameObject.SetActive(false);
				} else {
					transform.Find("sprite_group").Find("Player1_sprite"+body).Find("bonefeet").gameObject.SetActive(false);
				}
				
				transform.Find("sprite_group").Find("Player1_sprite"+body).Find(feet).LookAt(moveDirection * 100);
				transform.Find("sprite_group").Find("Player1_sprite"+body).Find(feet).rotation = Quaternion.Euler(new Vector3(90, transform.Find("sprite_group").Find("Player1_sprite"+body).Find(feet).rotation.eulerAngles.y, 0));
				if(gm.GetComponent(GameManager).worldMode == "overworld"){
					transform.Find("sprite_group").Find("Player1_sprite"+body).Find(feet).GetComponent(SpriteRenderer).color = new Color(0.9, 0.93, 0.92, 1);
				} else {
					transform.Find("sprite_group").Find("Player1_sprite"+body).Find(feet).GetComponent(SpriteRenderer).color = new Color(0.06, 0.34, 0.32, 0.5);
				}
			} else {
				transform.Find("sprite_group").Find("Player1_sprite"+body).Find("feet").gameObject.SetActive(false);
				transform.Find("sprite_group").Find("Player1_sprite"+body).Find("bonefeet").gameObject.SetActive(false);
			}
			
			
			var playerPlane = new Plane(Vector3.up, transform.position);
			var ray = Camera.main.ScreenPointToRay (Input.mousePosition);
			var hitdist = 0.0;
			var hit:RaycastHit;
			var lookTarget:Vector3;
			if (playerPlane.Raycast(ray, hitdist)) {
				lookTarget = ray.GetPoint(hitdist);
				transform.Find("sprite_group").LookAt(lookTarget);
				if(shielding){
					transform.Find("sprite_group").rotation = Quaternion.Euler(new Vector3(0, transform.Find("sprite_group").rotation.eulerAngles.y+40, 0));
				} else {
					transform.Find("sprite_group").rotation = Quaternion.Euler(new Vector3(0, transform.Find("sprite_group").rotation.eulerAngles.y, 0));
				}
			}

		}

		moveDirection.y -= gravity * Time.deltaTime; 
		controller.Move(moveDirection * Time.deltaTime); 
		
		if(Time.time - attackTime > 0.3){
			attacking = false;
		}
		
		if(Input.GetKey(KeyCode.LeftControl) || Input.GetKey(KeyCode.RightControl) || Input.GetKey(KeyCode.Space) || Input.GetMouseButton(1)){
			if(!attacking){
				shield();
			}
		}
		if(Input.GetKeyUp(KeyCode.LeftControl) || Input.GetKeyUp(KeyCode.RightControl) || Input.GetKeyUp(KeyCode.Space) || Input.GetMouseButtonUp(1)){
			unShield();
		}
		if(Input.GetMouseButtonDown(0)){
			if(!attacking){
				swingSword();
				unShield();
			}
		}
		
		if(swordHit){
			if(hitObject && hitObject.tag == "enemy"){
			
				Debug.Log("dabababa: "+hitObject.name);
				if(hitObject.name == "hero"){
					hitObject.GetComponent(enemyHeroController).health -= 20;
					if(hitObject.GetComponent(enemyHeroController).health <= 0){
						for(var ob in GameObject.FindGameObjectsWithTag("enemy")){
							if(ob.name ==  "esqueletus"){
								ob.GetComponent(enemyController).health = 0;
							}
						}
						gm.GetComponent(GameManager).cont_lives ++;
						health = 100;
						playerMode = "human";
						sucking = false;
						transform.Find("sprite_group").Find("Player1_sprite").GetComponent(SpriteRenderer).color = new Color(1, 1, 1, 1);
						transform.Find("sprite_group").Find("Player1_sprite").Find("evileyes").gameObject.SetActive(true);
						transform.Find("sprite_group").Find("Player1_sprite").Find("evileyes").gameObject.GetComponent(SpriteRenderer).color.a = 1;
					}
				} else if(hitObject.name == "spiritus"){
					gm.GetComponent(GameManager).cont_souls ++;
					hitObject.GetComponent(enemy2Controller).health = 0;
					sucking = false;
					gm.GetComponent(GameManager).showPortal();
				} else {
					gm.GetComponent(GameManager).cont_undead ++;
					hitObject.GetComponent(enemyController).health = 0;
				}
				hitObject = null;			
			}
		}
		
		if (impact.magnitude > 0.2F) {
			character.Move(impact * Time.deltaTime);
		}
		impact = Vector3.Lerp(impact, Vector3.zero, 5*Time.deltaTime);
		
		if(health/100 >= 0){
			transform.Find("ui_group").Find("life").localScale.x = health/100;
		} else {
				transform.Find("ui_group").Find("life").localScale.x = 0;
		}
		if(Time.time-ui_life_time > 2){
			transform.Find("ui_group").gameObject.SetActive(false);
		}
		
		if(health <= 0) {
			death();
		}
	
	} else {
		transform.Find("sprite_group").Find("Player1_sprite"+body).Find("feet").gameObject.SetActive(false);
		transform.Find("sprite_group").Find("Player1_sprite"+body).Find("bonefeet").gameObject.SetActive(false);		
	}
	
}

public function AddImpact(dir:Vector3, force:float){
	dir.Normalize();
	dir.y = 0;
	impact += dir.normalized * force / impactMass;
}

public function hurt(from:Vector3){
	var damage:float;
	transform.Find("ui_group").gameObject.SetActive(true);
	ui_life_time = Time.time;
	if(shielding){
		AddImpact(transform.position-from, 20);
		gm.GetComponent(GameManager).playSfx("clang");
		damage = 5;
		if(playerMode == "bone"){
			damage *= 5;
		}
		health -= damage;
	} else {
		damage = 20;
		if(playerMode == "bone"){
			damage *= 5;
		}
		health -= damage;
		gm.GetComponent(GameManager).playSfx("ow");	
	}
}

public function suck(){
	var damage:float;
	transform.Find("ui_group").gameObject.SetActive(true);
	ui_life_time = Time.time;
	
	damage = 15;
	health -= damage;
	gm.GetComponent(GameManager).playSfx("ow");	
	
	sucking = true;
	
}

function death(){
	gm.GetComponent(GameManager).pause = true;
	//ready = false;
	if(playerMode == "human" && gm.GetComponent(GameManager).worldMode == "overworld"){
		playerMode = "spirit";
		gm.GetComponent(GameManager).goToUnderWorld();
	} else if(playerMode == "spirit" && gm.GetComponent(GameManager).worldMode == "underworld"){
		playerMode = "bone";
		gm.GetComponent(GameManager).goToOverWorld();
	} else if(playerMode == "bone" && gm.GetComponent(GameManager).worldMode == "overworld"){
		//gm.GetComponent(GameManager).goToOverWorld();
		gm.GetComponent(GameManager).playSfx("croc_cracka");
		Debug.Log("GAME OVER");
		gm.GetComponent(GameManager).showEndScreen();
		//Application.LoadLevel("map1");
	}
}

function shield(){
	shielding = true;
}

function unShield(){
	shielding = false;
}

function swingSword(){

	attackTime = Time.time;
	attacking = true;
	var anims:Animator;
	if(playerMode == "bone"){
		anims = transform.Find("sprite_group").Find("Player1_sprite_bone").gameObject.GetComponent(Animator);
		anims.Play("ely_bone_attack");
		transform.Find("sprite_group").Find("Player1_sprite_bone").Find("attack_fx").gameObject.SetActive(true);
		transform.Find("sprite_group").Find("Player1_sprite_bone").Find("hitDetector").gameObject.SetActive(true);	
	} else {
		anims = transform.Find("sprite_group").Find("Player1_sprite").gameObject.GetComponent(Animator);
		anims.Play("ely_attack");
		transform.Find("sprite_group").Find("Player1_sprite").Find("attack_fx").gameObject.SetActive(true);
		transform.Find("sprite_group").Find("Player1_sprite").Find("hitDetector").gameObject.SetActive(true);
	}
	
	
	
	gm.GetComponent(GameManager).playSfx("blow");
	
}