﻿#pragma strict

public var health:float = 100.0;

public var gm:GameObject;
public var agent:NavMeshAgent;
private var deathSound:boolean = false;

public var attacking:boolean = false;
public var attackTime:float = 0.0f;

function Start(){
	gm = GameObject.Find("GameManager");
	agent = GetComponent(NavMeshAgent);
}

function FixedUpdate () {
	if(health > 0 && !gm.GetComponent(GameManager).pause){
		agent.SetDestination(GameObject.Find("Player1").transform.position);
	} else {
		agent.Stop();
	}
}

function Update () {
	
	if(!gm.GetComponent(GameManager).pause){
	
		var anims:Animator;
	
		if(attacking){
			if(Time.time - attackTime > 1){
				attacking = false;
				transform.Find("sprite").Find("hitDetector").gameObject.SetActive(false);
				anims = transform.Find("sprite").gameObject.GetComponent(Animator);
				anims.Play("spirit_idle");
			}
		}
		
		if(agent.remainingDistance <= 2.3){
			if(!attacking){
				attackTime = Time.time;
				attacking = true;
				anims = transform.Find("sprite").gameObject.GetComponent(Animator);
				anims.Play("spirit_attack");	
				transform.Find("sprite").Find("hitDetector").gameObject.SetActive(true);
				gm.GetComponent(GameManager).playSfx("bluw");	
			}
		}
		
		if(health > 0){
			var lookTarget:Vector3 = agent.destination;
			transform.Find("sprite").LookAt(lookTarget);
			transform.Find("sprite").rotation = Quaternion.Euler(new Vector3(90, transform.Find("sprite").rotation.eulerAngles.y, 0));
		} else {
			if(!deathSound){
				gm.GetComponent(GameManager).playSfx("spiritdeath");
				deathSound = true;
				var orb:GameObject = GameObject.Instantiate(Resources.Load("Prefabs/healthOrb", GameObject), transform.position, Quaternion.identity);
				orb.name = "orb";
				Destroy(this.gameObject);
			}
		}
		
	} /*else {
		//transform.Find("sprite").Find("feet").gameObject.SetActive(false);
	}*/
	
}