﻿#pragma strict

public var health:float = 100.0;

public var gm:GameObject;
public var agent:NavMeshAgent;
private var deathSound:boolean = false;

public var attacking:boolean = false;
public var attackTime:float = 0.0f;

function Start(){
	gm = GameObject.Find("GameManager");
	agent = GetComponent(NavMeshAgent);
}

function FixedUpdate () {
	if(health > 0 && !gm.GetComponent(GameManager).pause){
		if(GameObject.Find("Player1").GetComponent(PlayerController).playerMode == "bone"){
			if(GameObject.Find("hero")){
				agent.SetDestination(GameObject.Find("hero").transform.position);
			} else {
				agent.Stop();
			}
		} else {
			agent.SetDestination(GameObject.Find("Player1").transform.position);
		}
	} else {
		agent.Stop();
	}
}

function Update () {
	
	if(!gm.GetComponent(GameManager).pause){
	
		if(Time.time - attackTime > 2.5){
			attacking = false;
		}
		
		if(agent.remainingDistance <= 3){
			if(!attacking){
				transform.Find("sprite").Find("attack_fx").gameObject.SetActive(true);
				gm.GetComponent(GameManager).playSfx("bluw");	
			}
		}
		
		if(health > 0){
			var lookTarget:Vector3 = agent.destination;
			transform.Find("sprite").LookAt(lookTarget);
			transform.Find("sprite").rotation = Quaternion.Euler(new Vector3(90, transform.Find("sprite").rotation.eulerAngles.y, 0));
		} else {
			if(!deathSound){
				if (Random.Range(0.0, 1.0) > 0.5){
					gm.GetComponent(GameManager).playSfx("croc_cracka");
				} else {
					gm.GetComponent(GameManager).playSfx("croc_cracka2");
				}
				deathSound = true;
				GameObject.Instantiate(Resources.Load("Prefabs/Explo_bone", GameObject), transform.position, Quaternion.identity);
				Destroy(this.gameObject);
			}
		}
		
	} else {
		transform.Find("sprite").Find("feet").gameObject.SetActive(false);
	}
	
}