﻿#pragma strict

public var rate:float;
public var enemy_type:GameObject;
public var max_enemies:int;
public var max_simultaneous:int;
public var pack:int;
public var enemy_name:String;
public var working_world_mode:String;

private var elapsed_time:float = 0.0f;
private var spawn_count:int = 0;
private var gm:GameObject;

function Start () {
	gm = GameObject.Find("GameManager");
}

function Update () {
	if(!gm.GetComponent(GameManager).pause && gm.GetComponent(GameManager).worldMode == working_world_mode){
		if(enemy_name == "hero"){
			if(Time.time - elapsed_time > rate && GameObject.Find("Player1").GetComponent(PlayerController).playerMode == "bone"){
				spawn();
				elapsed_time = Time.time;
			}
		} else {
			if(Time.time - elapsed_time > rate){
				spawn();
				elapsed_time = Time.time;
			}
		}
	}
}

function spawn(){
	var simultaneous_count:int = 0;
	for(var go in GameObject.FindGameObjectsWithTag("enemy")){
		if(go.name == enemy_name){
			simultaneous_count ++;
		}
		if(simultaneous_count >= max_simultaneous){
			break;
		}
	}
	if(spawn_count < max_enemies && simultaneous_count < max_simultaneous){
		var current_batch = 0;
		for(var i= spawn_count;i< max_enemies; i++){
			if(current_batch < pack){
				
				var rndPosWithin:Vector3;
	            rndPosWithin = new Vector3(Random.Range(-1f, 1f), Random.Range(-1f, 1f), Random.Range(-1f, 1f));
	            rndPosWithin = transform.TransformPoint(rndPosWithin * .5f);
				
				var enemy:GameObject = GameObject.Instantiate(enemy_type,rndPosWithin, Quaternion.identity);
				enemy.name = enemy_name;
				spawn_count ++;
				current_batch ++;
			} else {
				break;
			}
		}
	}
}