﻿#pragma strict

public var health:float = 100.0;

public var gm:GameObject;
public var agent:NavMeshAgent;
private var deathSound:boolean = false;

public var attacking:boolean = false;
public var attackTime:float = 0.0f;

private var ui_life_time:float = 0.0;

function Start(){
	gm = GameObject.Find("GameManager");
	agent = GetComponent(NavMeshAgent);
}

function FixedUpdate () {
	if(health > 0 && !gm.GetComponent(GameManager).pause){
		var dist:float = Mathf.Abs((GameObject.Find("Player1").transform.position-transform.position).magnitude);
		agent.SetDestination(GameObject.Find("Player1").transform.position);
		for (var ob in GameObject.FindGameObjectsWithTag("enemy")){
			if(ob.name == "esqueletus"){
				var newdist = Mathf.Abs((ob.transform.position - transform.position).magnitude);
				if (newdist< dist){
					agent.SetDestination(ob.transform.position);
					break;
				}
			}
		}		
	} else {
		agent.Stop();
	}
}

function Update () {

	if(!gm.GetComponent(GameManager).pause){
	
		if(Time.time - attackTime > 1){
			attacking = false;
		}
		
		if(agent.remainingDistance <= 3){
			if(!attacking){
				transform.Find("sprite").Find("attack_fx").gameObject.SetActive(true);
				transform.Find("sprite").Find("hitDetector").gameObject.SetActive(true);
				var anims:Animator = transform.Find("sprite").gameObject.GetComponent(Animator);
				anims.Play("ely_attack");
				attacking = true;
				attackTime = Time.time;
				gm.GetComponent(GameManager).playSfx("blow");	
			}
		}
		
		if(health/100 >= 0){
			transform.Find("ui_group").Find("life").localScale.x = health/100;
		} else {
			transform.Find("ui_group").Find("life").localScale.x = 0;
		}
		transform.Find("ui_group").rotation = Quaternion.identity;
		if(Time.time-ui_life_time > 2){
			transform.Find("ui_group").gameObject.SetActive(false);
		}
		
		if(health > 0){
			var lookTarget:Vector3 = agent.destination;
			transform.Find("sprite").LookAt(lookTarget);
			transform.Find("sprite").rotation = Quaternion.Euler(new Vector3(90, transform.Find("sprite").rotation.eulerAngles.y, 0));
		} else {
			if(!deathSound){
				if (Random.Range(0.0, 1.0) > 0.5){
					gm.GetComponent(GameManager).playSfx("croc_cracka");
				} else {
					gm.GetComponent(GameManager).playSfx("croc_cracka2");
				}
				deathSound = true;
				Destroy(this.gameObject);
			}
		}
		
	} else {
		transform.Find("sprite").Find("feet").gameObject.SetActive(false);
	}	
}

public function hurt(from:Vector3){
	/*if(shielding){
		AddImpact(transform.position-from, 20);
		gm.GetComponent(GameManager).playSfx("clang");		
	} else {*/
		transform.Find("ui_group").gameObject.SetActive(true);
		ui_life_time = Time.time;
		health -= 20;
		gm.GetComponent(GameManager).playSfx("ow");	
	//}
}
